<?php

use Illuminate\Support\Facades\DB;
use App\Article;
use Codexshaper\WooCommerce\Facades\Product;
use Codexshaper\WooCommerce\Facades\Variation;

function showarray($array)
{
    echo '<pre>' . json_encode($array, JSON_PRETTY_PRINT) . '</pre>';
};

function isKeyPresent($array, $key)
{
    foreach ($array as $item) {
        if (isset($item->key) && $item->key === $key) {
            return true;
        }
    }
    return false;
}

function getValueByKey($array, $key)
{
    foreach ($array as $item) {
        if (isset($item->key) && $item->key === $key) {
            return $item->value;
        }
    }
    return null; // If key is not found
}

// Funzione per aggiornare il valore di un certo key in un array di oggetti
function updateValueByKey(&$array, $key, $newValue)
{
    foreach ($array as &$item) {
        if (is_object($item) && property_exists($item, 'key') && $item->key === $key) {
            $item->value = $newValue;
            return; // Se trova il key, termina il loop
        }
    }

    // Se il key non esiste nell'array, aggiungi il nuovo key-value pair
    $newItem = new stdClass();
    $newItem->key = $key;
    $newItem->value = $newValue;

    $array[] = $newItem; // Aggiungi il nuovo elemento all'array
}

function updateValueByKeyArr(&$array, $key, $newValue)
{
    foreach ($array as &$item) {
        if ($item['key'] === $key) {
            $item['value'] = $newValue;
            break; // Se trova il key, termina il loop
        }
    }

    $array[$key] = $newValue;
}

function setPreOrderByIdArticolo($idarticolo, $aggiornapreordine, $debug)
{
    return setPreOrder($idarticolo, $aggiornapreordine, $debug);
}

function setPreOrder($sku, $aggiornapreordine, $debug)
{
    try {
        // Aggiorna Preorder
        $product = Product::where('sku', $sku)->first();

        // get the article by product
        // $article = Article::where('IdArticolo', $idarticolo)->first();

        // showarray($article);

        if ($debug) {
            echo "Product: " . $sku;
            showarray($product);
        }


        $campoPreOrder = '_wpro_variable_is_preorder';

        if ($product) {
            $titolo = $product['name'];

            if ($debug)
                echo "Prodotto trovato: " . $titolo . "StockQty = " . $product['stock_quantity'] . "<br>";

            $preorder = false;
            if (isKeyPresent($product['meta_data'], $campoPreOrder)) {
                $preorder = getValueByKey($product['meta_data'], $campoPreOrder);
            }

            if ($debug) {
                if ($preorder) {
                    if ($preorder === 'true') {
                        echo "<span class='badge badge-success' style='color: green;'>PREORDER SI !</span>: " . $preorder;
                    } else {
                        echo "<span class='badge badge-success' style='color: green;'>PREORDER:</span>: " . $preorder;
                    }
                } else {
                    echo "<span style='color: red;'>preorder non presente !</span>: ";
                }
                echo "<br>";
            }

            if ($aggiornapreordine === '1') {
                $data = [];

                $datenow = date('Y-m-d');

                $idprodotto = $product['parent_id'];
                if ($idprodotto > 0) {

                    if ($debug)
                        echo "Variazioni: " . $product['parent_id'] . "<br>";
                    $variations = Variation::all($product['parent_id']);
                    if ($debug)
                        showarray($variations);
                    for ($i = 0; $i < count($variations); $i++) {
                        $variation = $variations[$i];
                        if ($variation->id == $product['id']) {
                            // convert object into array
                            $data = json_decode(json_encode($variation), true);
                            break;
                        }
                    }

                    $data['stock_quantity'] = '1000';

                    if ($debug) {
                        echo "Data:";
                        showarray($data);
                    }

                    $agg = true;
                    $data['meta_data'] = $product['meta_data'];
                    if ($agg) {
                        updateValueByKey($data['meta_data'], $campoPreOrder, 'yes');
                        updateValueByKey($data['meta_data'], '_is_pre_order', 'yes');
                        updateValueByKey($data['meta_data'], '_pre_order_date', $datenow);
                        updateValueByKey($data['meta_data'], '_wpro_date_label_variable', '');
                        updateValueByKey($data['meta_data'], '_wpro_no_date_label_variable', '');
                        updateValueByKey($data['meta_data'], '_wpro_manage_price_variable', '');
                        updateValueByKey($data['meta_data'], '_wpro_price_variable', '');
                        updateValueByKey($data['meta_data'], '_wpro_label_variable', 'Pre Ordinalo!');
                        updateValueByKey($data['meta_data'], '_wpro_price_type_variable', 'manual');
                        updateValueByKey($data['meta_data'], '_wpro_amount_price_variable', 'fixed');
                        updateValueByKey($data['meta_data'], '_wpro_date_variable', '');
                        updateValueByKey($data['meta_data'], '_wpro_time_variable', '');
                        updateValueByKey($data['meta_data'], '_rank_math_gtin_code', '');
                    }

                    if ($debug) {
                        echo "<br>Dati da Salvare:";
                        showarray($data);
                    }

                    $variation = Variation::update($idprodotto, $product['id'], $data);

                    if ($variation) {
                        if ($debug)
                            echo "Aggiornato Preorder: [ParentId=" . $idprodotto . '] ProdId= ' . $product['id'] . ' ' . $variation['name'] . "<br>";
                    }
                }
            }
        } else {
            if ($debug)
                echo "Il prodotto non esiste";
        }
    } catch (Exception $e) {
        echo "Errore: " . $e->getMessage();
    }
}

function isArticleInPrevendita($id)
{
    return loadArticleByIdArticle($id, true);
}


function loadArticleByIdArticle($id, $checkprevendita = false)
{

    try {
        $articles = Article::join(DB::raw('(SELECT IdArticolo, MAX(DataOra) AS data FROM T_WEB_Articoli GROUP BY IdArticolo) b'), function ($join) {
            $join->on('T_WEB_Articoli.IdArticolo', '=', 'b.IdArticolo')
                ->on('T_WEB_Articoli.DataOra', '=', 'b.data');
        })
            ->leftJoin(DB::raw('(SELECT e.IdStatoProdotto, e.Descrizione as DescrizioneStatoProdotto FROM T_WEB_StatiProdotto e JOIN (SELECT IdStatoProdotto, MAX(DataOra) as data1 from T_WEB_StatiProdotto GROUP BY IdStatoProdotto) c ON e.IdStatoProdotto = c.IdStatoProdotto AND e.DataOra = c.data1 ) f'), function ($join) {
                $join->on('T_WEB_Articoli.IdStatoProdotto', '=', 'f.IdStatoProdotto');
            })
            ->leftJoin(DB::raw('(SELECT o.Codice, o.QtaDisponibile FROM T_WEB_Disponibile o JOIN (SELECT Codice, MAX(DataOra) as data1 from T_WEB_Disponibile GROUP BY Codice) p ON o.Codice = p.Codice AND o.DataOra = p.data1 ) q'), function ($join) {
                $join->on('T_WEB_Articoli.IdArticolo', '=', 'q.Codice');
            })
            ->where('T_WEB_Articoli.IdArticolo', $id)
            ->get();

            if ($checkprevendita) {
                foreach ($articles as $article) {
                    $qtaneg = $article->QtaDisponibile < 0;
                    $inprevendita = false;
                    if ($article) {
                        $inprevendita = $qtaneg
                            && ($article->DescrizioneStatoProdotto === 'In prevendita');
                    }
                    if ($inprevendita) {
                        return true;
                    }
                }
                return false;
            }

        return dd($articles);
    } catch (\Exception $e) {

        return "Errore: " . $e->getMessage();
    }
}
